//Find AdminLogin and rewrite it with our hook as conditional

/*
// This
exec function AdminLogin( string Password )
{
	Level.Game.AdminLogin( Self, Password );
}

// Into
exec function AdminLogin( string Password )
{
	if ( AdminLoginHook( self) )
		Level.Game.AdminLogin( Self, Password );
}
*/


void UXC_GameEngine::ReplaceAdminLoginFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceAdminLoginFunc);

	if ( b451Setup ) //We don't need this here
		return;

	UFunction* AdminLogin = FindBaseFunction( APlayerPawn::StaticClass(), TEXT("AdminLogin"));
	if ( !AdminLogin ) //Script not serialized?
		return;

	GNatives[3551] = (Native)&UObject::execUndefined;
	if ( OldAdminLogin.IsCleared() && (!bSet || !OldAdminLogin.Setup( &AdminLogin->Script )) )
		return;
	
	if ( !bSet )
	{
		OldAdminLogin.Restore( &AdminLogin->Script);
		if ( bEnableDebugLogs )
			debugf( NAME_XC_Engine, TEXT("Reverting PlayerPawn.AdminLogin hook") );
		return;
	}
	else if ( OldAdminLogin.MismatchSize(&AdminLogin->Script) )
		return;
	
	//Initialize remaining vars
	INT Found = 0;
	UProperty* Password = FindScriptVariable( AdminLogin, TEXT("Password"), &Found);
	UProperty* Level = FindScriptVariable( AActor::StaticClass(), TEXT("Level"), &Found);
	UProperty* Game = FindScriptVariable( ALevelInfo::StaticClass(), TEXT("Game"), &Found);
	check( Found == 3 );

	AdminLogin->Script.Empty();
	AdminLogin->Script.AddZeroed( 39);
	
	BYTE* Block = &AdminLogin->Script( 0);

	JumpToIfNot( Block, 37);				Block += 3; // (3)
	GNatives[3551] = (Native)&AXC_DummyPawn::AdminLoginNative;
	HighNative( Block, 3551);				Block += 2; // (5)
	*Block++ = EX_Self;	// (6)
	*Block++ = EX_EndFunctionParms; // (7)
	*Block++ = EX_Context; // (8)
	_obj_SingleContext( Block, 1, Level);	Block += 9; // (17)
	ParseInstanceVariable( Block, Game);	Block += 5; // (22)
	*Block++ = 0x0C; // (23)
	*Block++ = 0x00; // (24)
	*Block++ = 0x00; // (25)
	*Block++ = EX_VirtualFunction; // (26)
	WriteINT( Block, AdminLogin->GetFName().GetIndex() );	Block += 4; // (30)
	*Block++ = EX_Self;	// (31)
	ParseLocalVariable( Block, Password);	Block += 5; // (36)
	*Block++ = EX_EndFunctionParms; // (37)
	
	AddReturn( Block); // (39)

	if ( bEnableDebugLogs )
		debugf( NAME_XC_Engine, TEXT("PlayerPawn.AdminLogin hook success"));
	unguard;
}

struct UHack_eventAdminLoginHook_Parms
{
	class APlayerPawn* P;
	BITFIELD ReturnValue;
};

//Called on PlayerPawn context
void AXC_DummyPawn::AdminLoginNative(FFrame &Stack, RESULT_DECL)
{
	guard( AdminLoginNative );
	P_GET_OBJECT(APlayerPawn,P);
	P_FINISH;
	*(UBOOL*)Result = 1;
	if ( P )
	{
		UXC_GameEngine* Xg = Cast<UXC_GameEngine>(XLevel->Engine);
		if ( Xg && Xg->AdminLoginHook && !Xg->AdminLoginHook->bDeleteMe )
		{
			FName NAME_AdminLoginHook = FName( TEXT("AdminLoginHook"), FNAME_Find); //Dynamically find name
			if ( NAME_AdminLoginHook != NAME_None )
			{
				UHack_eventAdminLoginHook_Parms Parms;
				Parms.P = P;
				Parms.ReturnValue = 0;
				Xg->AdminLoginHook->ProcessEvent( Xg->AdminLoginHook->FindFunctionChecked(NAME_AdminLoginHook),&Parms);
				*(UBOOL*)Result = Parms.ReturnValue;
			}
		}
	}
	unguard;
}
